Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 766)
@@ -3,4 +3,6 @@
 !
 c
+c#define IO_DEBUG
+
       SUBROUTINE physiq (nlon,nlev,nqmax,
      .            debut,lafin,rjourvrai,gmtime,pdtphys,
@@ -16,12 +18,10 @@
 
       USE ioipsl
-      USE histcom
-#ifdef INCA
-      USE chemshut
-      USE species_names
-#ifdef INCA_CH4
-!      USE obs_pos
-#endif
-#endif
+      USE comgeomphy
+      USE write_field_phy
+      USE dimphy
+      USE iophy
+      USE misc_mod, mydebug=>debug
+      USE vampir
       IMPLICIT none
 c======================================================================
@@ -37,10 +37,10 @@
 c   CLEFS CPP POUR LES IO
 c   =====================
-#define histins
-#define histhf
-#define histday
+c#define histhf
+c#define histday
 #define histmth
-#define histmthNMC
-#define histISCCP
+c#define histins
+c#define histmthNMC
+c#define histISCCP
 c======================================================================
 c    modif   ( P. Le Van ,  12/10/98 )
@@ -80,5 +80,7 @@
       integer jjmp1
       parameter (jjmp1=jjm+1-1/jjm)
-#include "dimphy.h"
+      integer iip1
+      parameter (iip1=iim+1)
+cym#include "dimphy.h"
 #include "regdim.h"
 #include "indicesol.h"
@@ -88,5 +90,5 @@
 #include "logic.h"
 #include "temps.h"
-#include "comgeomphy.h"
+cym#include "comgeomphy.h"
 #include "advtrac.h"
 #include "iniprint.h"
@@ -106,4 +108,5 @@
 #include "oasis.h"
       INTEGER,SAVE :: npas, nexca
+c$OMP THREADPRIVATE(npas, nexca)
       logical rnpb
 #ifdef INCA
@@ -115,9 +118,10 @@
       character*6 ocean
       SAVE ocean
-
+c$OMP THREADPRIVATE(ocean)
 c      parameter (ocean = 'force ')
 c     parameter (ocean = 'couple')
       logical ok_ocean
       SAVE ok_ocean
+c$OMP THREADPRIVATE(ok_ocean)
 c
 cIM "slab" ocean
@@ -137,4 +141,5 @@
       logical ok_veget
       save ok_veget
+c$OMP THREADPRIVATE(ok_veget)
 c     parameter (ok_veget = .true.)
 c      parameter (ok_veget = .false.)
@@ -156,12 +161,15 @@
       LOGICAL ok_journe ! sortir le fichier journalier
       save ok_journe
+c$OMP THREADPRIVATE(ok_journe)
 c      PARAMETER (ok_journe=.true.)
 c
       LOGICAL ok_mensuel ! sortir le fichier mensuel
       save ok_mensuel
+c$OMP THREADPRIVATE(ok_mensuel)
 c      PARAMETER (ok_mensuel=.true.)
 c
       LOGICAL ok_instan ! sortir le fichier instantane
       save ok_instan
+c$OMP THREADPRIVATE(ok_instan)
 c      PARAMETER (ok_instan=.true.)
 c
@@ -172,6 +180,7 @@
       REAL fm_therm(klon,klev+1)
       REAL entr_therm(klon,klev)
-      real q2(klon,klev+1,nbsrf)
-      save q2
+      real,allocatable,save :: q2(:,:,:)
+c$OMP THREADPRIVATE(q2)
+cym      save q2
 c======================================================================
 c
@@ -207,9 +216,10 @@
       REAL qx(klon,klev,nqmax)
 
-      REAL t_ancien(klon,klev), q_ancien(klon,klev)
-      SAVE t_ancien, q_ancien
+      REAL,allocatable,save :: t_ancien(:,:), q_ancien(:,:)
+c$OMP THREADPRIVATE(t_ancien, q_ancien)
+cym      SAVE t_ancien, q_ancien
       LOGICAL ancien_ok
       SAVE ancien_ok
-
+c$OMP THREADPRIVATE(ancien_ok)
       REAL d_t_dyn(klon,klev)
       REAL d_q_dyn(klon,klev)
@@ -233,6 +243,10 @@
       CHARACTER*3 ctetaSTD(nbteta)
       DATA ctetaSTD/'350','380','405'/
+      SAVE ctetaSTD
+c$OMP THREADPRIVATE(ctetaSTD)
       REAL rtetaSTD(nbteta)
       DATA rtetaSTD/350., 380., 405./
+      SAVE rtetaSTD
+c$OMP THREADPRIVATE(rtetaSTD)     
 c
       REAL PVteta(klon,nbteta)
@@ -241,26 +255,32 @@
 cMI Amip2 PV a theta constante
 
-      INTEGER klevp1, klevm1
-      PARAMETER(klevp1=klev+1,klevm1=klev-1)
-#include "raddim.h"
-c
-      REAL swdn0(klon,klevp1), swdn(klon,klevp1)
-      REAL swup0(klon,klevp1), swup(klon,klevp1)
-      SAVE swdn0 , swdn, swup0, swup
-c
-      REAL SWdn200clr(klon), SWdn200(klon)
-      REAL SWup200clr(klon), SWup200(klon)
-      SAVE SWdn200clr, SWdn200, SWup200clr, SWup200
-c
-      REAL lwdn0(klon,klevp1), lwdn(klon,klevp1)
-      REAL lwup0(klon,klevp1), lwup(klon,klevp1)
-      SAVE lwdn0 , lwdn, lwup0, lwup 
-c
-      REAL LWdn200clr(klon), LWdn200(klon)
-      REAL LWup200clr(klon), LWup200(klon)
-      SAVE LWdn200clr, LWdn200, LWup200clr, LWup200
-c
-      REAL LWdnTOA(klon), LWdnTOAclr(klon)
-      SAVE LWdnTOA, LWdnTOAclr
+cym      INTEGER klevp1, klevm1
+cym      PARAMETER(klevp1=klev+1,klevm1=klev-1)
+cym#include "raddim.h"
+c
+
+      REAL,allocatable,save :: swdn0(:,:), swdn(:,:)
+      REAL,allocatable,save :: swup0(:,:), swup(:,:)
+c$OMP THREADPRIVATE(swdn0 , swdn, swup0, swup)
+cym      SAVE swdn0 , swdn, swup0, swup
+c
+      REAL,allocatable,save :: SWdn200clr(:), SWdn200(:)
+      REAL,allocatable,save :: SWup200clr(:), SWup200(:)
+c$OMP THREADPRIVATE(SWdn200clr, SWdn200, SWup200clr, SWup200)
+cym      SAVE SWdn200clr, SWdn200, SWup200clr, SWup200
+c
+      REAL,allocatable,save :: lwdn0(:,:), lwdn(:,:)
+      REAL,allocatable,save :: lwup0(:,:), lwup(:,:)
+c$OMP THREADPRIVATE(lwdn0 , lwdn, lwup0, lwup)
+cym      SAVE lwdn0 , lwdn, lwup0, lwup 
+c
+      REAL,allocatable,save :: LWdn200clr(:), LWdn200(:)
+      REAL,allocatable,save :: LWup200clr(:), LWup200(:)
+c$OMP THREADPRIVATE(LWdn200clr, LWdn200, LWup200clr, LWup200)
+cym      SAVE LWdn200clr, LWdn200, LWup200clr, LWup200
+c
+      REAL,allocatable,save :: LWdnTOA(:), LWdnTOAclr(:)
+c$OMP THREADPRIVATE(LWdnTOA, LWdnTOAclr)
+cym      SAVE LWdnTOA, LWdnTOAclr
 c
 cIM Amip2
@@ -273,8 +293,12 @@
      .60000., 50000., 40000., 30000., 25000., 20000.,
      .15000., 10000., 7000., 5000., 3000., 2000., 1000./
+      SAVE rlevstd
+c$OMP THREADPRIVATE(rlevSTD)
       CHARACTER*4 clevSTD(nlevSTD)
       DATA clevSTD/'1000','925 ','850 ','700 ','600 ',
      .'500 ','400 ','300 ','250 ','200 ','150 ','100 ',
      .'70  ','50  ','30  ','20  ','10  '/
+      SAVE clevSTD
+c$OMP THREADPRIVATE(clevSTD)
 c
       CHARACTER*3 bb2
@@ -290,15 +314,18 @@
       PARAMETER(nout=3) !nout=1 : day; =2 : mth; =3 : NMC
 c
-      REAL tsumSTD(klon,nlevSTD,nout)
-      REAL usumSTD(klon,nlevSTD,nout), vsumSTD(klon,nlevSTD,nout)
-      REAL wsumSTD(klon,nlevSTD,nout), phisumSTD(klon,nlevSTD,nout)
-      REAL qsumSTD(klon,nlevSTD,nout), rhsumSTD(klon,nlevSTD,nout)
-c
-      SAVE tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD, 
-     .     qsumSTD, rhsumSTD
+      REAL,SAVE,ALLOCATABLE :: tsumSTD(:,:,:)
+      REAL,SAVE,ALLOCATABLE :: usumSTD(:,:,:), vsumSTD(:,:,:)
+      REAL,SAVE,ALLOCATABLE :: wsumSTD(:,:,:), phisumSTD(:,:,:)
+      REAL,SAVE,ALLOCATABLE :: qsumSTD(:,:,:), rhsumSTD(:,:,:)
+c
+cym      SAVE tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD, 
+cym     .     qsumSTD, rhsumSTD
+c$OMP THREADPRIVATE(tsumSTD, usumSTD, vsumSTD, wsumSTD, phisumSTD) 
+c$OMP THREADPRIVATE(qsumSTD, rhsumSTD)
 c
       logical oknondef(klon,nlevSTD,nout)
-      real tnondef(klon,nlevSTD,nout) 
-      save tnondef
+      real,SAVE,ALLOCATABLE :: tnondef(:,:,:) 
+c$OMP THREADPRIVATE(tnondef)
+cym      save tnondef
 c
 c les produits uvSTD, vqSTD, .., T2STD sont calcules
@@ -311,8 +338,8 @@
       real wqSTD(klon,nlevSTD)
 c
-      real uvsumSTD(klon,nlevSTD,nout)
-      real vqsumSTD(klon,nlevSTD,nout)
-      real vTsumSTD(klon,nlevSTD,nout)
-      real wqsumSTD(klon,nlevSTD,nout)
+      real,save,allocatable :: uvsumSTD(:,:,:)
+      real,save,allocatable :: vqsumSTD(:,:,:)
+      real,save,allocatable :: vTsumSTD(:,:,:)
+      real,save,allocatable :: wqsumSTD(:,:,:)
 c
       real vphiSTD(klon,nlevSTD)
@@ -322,12 +349,15 @@
       real T2STD(klon,nlevSTD)
 c
-      real vphisumSTD(klon,nlevSTD,nout)
-      real wTsumSTD(klon,nlevSTD,nout)
-      real u2sumSTD(klon,nlevSTD,nout)
-      real v2sumSTD(klon,nlevSTD,nout)
-      real T2sumSTD(klon,nlevSTD,nout)
-c
-      SAVE uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD
-      SAVE vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD
+      real,save,allocatable :: vphisumSTD(:,:,:)
+      real,save,allocatable :: wTsumSTD(:,:,:)
+      real,save,allocatable :: u2sumSTD(:,:,:)
+      real,save,allocatable :: v2sumSTD(:,:,:)
+      real,save,allocatable :: T2sumSTD(:,:,:)
+c
+cym      SAVE uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD
+cym      SAVE vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD
+c$OMP THREADPRIVATE(uvsumSTD, vqsumSTD, vTsumSTD, wqsumSTD)
+c$OMP THREADPRIVATE(vphisumSTD, wTsumSTD, u2sumSTD, v2sumSTD, T2sumSTD)
+
 cMI Amip2
 c
@@ -347,5 +377,5 @@
       REAL cldt_s(klon),cldq_s(klon) !nuage total, eau liquide integree
 
-      INTEGER kp1
+      INTEGER linv, kp1
 c flwp, fiwp = Liquid Water Path & Ice Water Path (kg/m2)
 c flwc, fiwc = Liquid Water Content & Ice Water Content (kg/kg)
@@ -361,6 +391,6 @@
 cv3.4
       INTEGER debug, debugcol
-      INTEGER npoints
-      PARAMETER(npoints=klon) 
+cym      INTEGER npoints
+cym      PARAMETER(npoints=klon) 
 c
       INTEGER sunlit(klon) !sunlit=1 if day; sunlit=0 if night
@@ -382,9 +412,14 @@
       DATA ifreq_isccp/3/
       SAVE ifreq_isccp
+c$OMP THREADPRIVATE(ifreq_isccp)
       CHARACTER*5 typinout(napisccp)
       DATA typinout/'i3od'/
+      SAVE typinout
+c$OMP THREADPRIVATE(typinout)
 cIM verif boxptop BEG
       CHARACTER*1 verticaxe(napisccp)
       DATA verticaxe/'1'/ 
+      SAVE verticaxe
+c$OMP THREADPRIVATE(verticaxe)
 cIM verif boxptop END
       INTEGER nvlev(napisccp)
@@ -392,12 +427,16 @@
       REAL t1, aa
       REAL seed_re(klon,napisccp)
-      INTEGER seed_old(klon,napisccp)
-      SAVE seed_old
-      INTEGER iphy(iim,jjmp1)
+      INTEGER,ALLOCATABLE,SAVE :: seed_old(:,:)
+cym      SAVE seed_old
+c$OMP THREADPRIVATE(seed_old)
+cym !!!! A voir plus tard 
+cym      INTEGER iphy(iim,jjmp1)
 cIM parametres ISCCP END
 c
 c ncol = nb. de sous-colonnes pour chaque maille du GCM 
 c ncolmx = No. max. de sous-colonnes pour chaque maille du GCM 
-      INTEGER ncol(napisccp), ncolmx, seed(klon,napisccp)
+c      INTEGER ncol(napisccp), ncolmx, seed(klon,napisccp)
+      INTEGER,SAVE :: ncol(napisccp)
+      INTEGER ncolmx, seed(klon,napisccp)
       REAL nbsunlit(nregISCtot,klon,napisccp)  !nbsunlit : moyenne de sunlit
       PARAMETER(ncolmx=1500)
@@ -407,6 +446,7 @@
 cIM verif boxptop END
 c
-      REAL tautab(0:255)
-      INTEGER invtau(-20:45000)
+      REAL,SAVE :: tautab_omp(0:255),tautab(0:255)
+      INTEGER,SAVE :: invtau_omp(-20:45000),invtau(-20:45000)
+c$OMP THREADPRIVATE(tautab,invtau)
       REAL emsfc_lw
       PARAMETER(emsfc_lw=0.99)
@@ -456,4 +496,6 @@
       INTEGER iw, iwmax
       REAL wmin, pas_w
+c     PARAMETER(wmin=-100.,pas_w=10.,iwmax=30)
+cIM 051005     PARAMETER(wmin=-200.,pas_w=10.,iwmax=40)
       PARAMETER(wmin=-100.,pas_w=10.,iwmax=20)
       REAL o500(klon)
@@ -465,6 +507,7 @@
 
       INTEGER linv
-      INTEGER pct_ocean(klon,nbregdyn)
-      SAVE pct_ocean
+      INTEGER,ALLOCATABLE,SAVE :: pct_ocean(:,:)
+c$OMP THREADPRIVATE(pct_ocean)
+cym      SAVE pct_ocean
  
 c sorties ISCCP
@@ -472,13 +515,27 @@
       integer nid_isccp
       save nid_isccp        
+c$OMP THREADPRIVATE(nid_isccp)
+
+c     data ok_isccp,ecrit_isccp/.true.,0.125/      
+c     data ok_isccp,ecrit_isccp/.true.,1./      
+cIM 190504     data ok_isccp/.true./      
+cIM 190504 #else
+cIM 190504     data ok_isccp/.false./
+cIM 190504 #endif
 
       REAL zx_tau(kmaxm1), zx_pc(lmaxm1), zx_o500(iwmax)
       DATA zx_tau/0.0, 0.3, 1.3, 3.6, 9.4, 23., 60./
+      SAVE zx_tau
+cIM bad 151205     DATA zx_pc/50., 180., 310., 440., 560., 680., 800./
       DATA zx_pc/180., 310., 440., 560., 680., 800., 1000./
-
+      SAVE zx_pc
+c$OMP THREADPRIVATE(zx_tau,zx_pc)
 c cldtopres pression au sommet des nuages
       REAL cldtopres(lmaxm1), cldtopres3(lmax3)
       DATA cldtopres/180., 310., 440., 560., 680., 800., 1000./
       DATA cldtopres3/440., 680., 1000./
+      SAVE cldtopres,cldtopres3
+c$OMP THREADPRIVATE(cldtopres,cldtopres3)
+cIM 051005 BEG
       REAL tmp_his1_3d(iwmax,kmaxm1,lmaxm1,nbregdyn,napisccp) 
       REAL tmp_his2_3d(iwmax,kmaxm1,lmaxm1,nbregdyn,napisccp) 
@@ -492,4 +549,6 @@
       CHARACTER *3 pclev(lmaxm1)
       DATA pclev/'pc1','pc2','pc3','pc4','pc5','pc6','pc7'/
+      SAVE taulev,pclev
+c$OMP THREADPRIVATE(taulev,pclev)
 c
 c cnameisccp
@@ -545,4 +604,6 @@
      .                'pc= 680-800hPa, tau> 60.',
      .                'pc= 800-1000hPa, tau> 60.'/
+       SAVE cnameisccp
+c$OMP THREADPRIVATE(cnameisccp)
 c
 c     REAL zx_lonx7(iimx7), zx_latx7(jjmp1x7)
@@ -558,5 +619,5 @@
       integer nid_hf, nid_hf3d
       save ok_hf, nid_hf, nid_hf3d
-
+c$OMP THREADPRIVATE(ok_hf, nid_hf, nid_hf3d)
 c  QUESTION : noms de variables ?
 
@@ -566,5 +627,4 @@
       data ok_hf/.false./
 #endif
-
       INTEGER        longcles
       PARAMETER    ( longcles = 20 )
@@ -575,4 +635,5 @@
       REAL xjour
       SAVE xjour
+c$OMP THREADPRIVATE(xjour)
 c
 c
@@ -581,19 +642,25 @@
       REAL dtime
       SAVE dtime                  ! pas temporel de la physique
+c$OMP THREADPRIVATE(dtime)
 c
       INTEGER radpas
       SAVE radpas                 ! frequence d'appel rayonnement
-c
-      REAL radsol(klon)
-      SAVE radsol               ! bilan radiatif au sol calcule par code radiatif
-c
-      REAL rlat(klon)
-      SAVE rlat                   ! latitude pour chaque point
-c
-      REAL rlon(klon)
-      SAVE rlon                   ! longitude pour chaque point
-c
-      REAL rlonPOS(klon)
-      SAVE rlonPOS                ! longitudes > 0. pour chaque point
+c$OMP THREADPRIVATE(radpas)
+c
+      REAL,allocatable,save :: radsol(:)
+c$OMP THREADPRIVATE(radsol)
+cym      SAVE radsol               ! bilan radiatif au sol calcule par code radiatif
+c
+      REAL,allocatable,save :: rlat(:)
+c$OMP THREADPRIVATE(rlat)
+cym      SAVE rlat                   ! latitude pour chaque point
+c
+      REAL,allocatable,save :: rlon(:)
+c$OMP THREADPRIVATE(rlon)
+cym      SAVE rlon                   ! longitude pour chaque point
+
+      REAL,SAVE,ALLOCATABLE :: rlonPOS(:)
+c$OMP THREADPRIVATE(rlonPOS)    
+cym      SAVE rlonPOS                ! longitudes > 0. pour chaque point
 c
 cc      INTEGER iflag_con
@@ -602,4 +669,5 @@
       INTEGER itap
       SAVE itap                   ! compteur pour la physique
+c$OMP THREADPRIVATE(itap)
 c
       REAL co2_ppm_etat0
@@ -609,34 +677,46 @@
       real slp(klon) ! sea level pressure
 
-      REAL ftsol(klon,nbsrf)
-      SAVE ftsol                  ! temperature du sol
+      REAL,allocatable,save :: ftsol(:,:)
+c$OMP THREADPRIVATE(ftsol)
+cym      SAVE ftsol                  ! temperature du sol
+
 cIM
-      REAL newsst(klon) !temperature de l'ocean
-      SAVE newsst
-c
-      REAL ftsoil(klon,nsoilmx,nbsrf)
-      SAVE ftsoil                 ! temperature dans le sol
-c
-      REAL fevap(klon,nbsrf)
-      SAVE fevap                 ! evaporation
-      REAL fluxlat(klon,nbsrf)
-      SAVE fluxlat
-c
-      REAL deltat(klon)
-      SAVE deltat                 ! ecart avec la SST de reference
-c
-      REAL fqsurf(klon,nbsrf)
-      SAVE fqsurf                 ! humidite de l'air au contact de la surface
-c
-      REAL qsol(klon)
-      SAVE qsol                  ! hauteur d'eau dans le sol
-c
-      REAL fsnow(klon,nbsrf)
-      SAVE fsnow                  ! epaisseur neigeuse
-c
-      REAL falbe(klon,nbsrf)
-      SAVE falbe                  ! albedo par type de surface
-      REAL falblw(klon,nbsrf)
-      SAVE falblw                 ! albedo par type de surface
+      REAL,SAVE,ALLOCATABLE :: newsst(:) !temperature de l'ocean
+c$OMP THREADPRIVATE(newsst)
+cym     SAVE newsst
+c
+      REAL,allocatable,save :: ftsoil(:,:,:)
+c$OMP THREADPRIVATE(ftsoil)
+cym      SAVE ftsoil                 ! temperature dans le sol
+c
+      REAL,allocatable,save :: fevap(:,:)
+c$OMP THREADPRIVATE(fevap)
+cym      SAVE fevap                 ! evaporation
+      REAL,allocatable,save :: fluxlat(:,:)
+c$OMP THREADPRIVATE(fluxlat)
+cym      SAVE fluxlat
+c
+      REAL,allocatable,save :: deltat(:)
+c$OMP THREADPRIVATE(deltat)
+cym      SAVE deltat                 ! ecart avec la SST de reference
+c
+      REAL,allocatable,save :: fqsurf(:,:)
+c$OMP THREADPRIVATE(fqsurf)
+cym      SAVE fqsurf                 ! humidite de l'air au contact de la surface
+c
+      REAL,allocatable,save :: qsol(:)
+c$OMP THREADPRIVATE(qsol)
+cym      SAVE qsol                  ! hauteur d'eau dans le sol
+c
+      REAL,allocatable,save :: fsnow(:,:)
+c$OMP THREADPRIVATE(fsnow)
+cym      SAVE fsnow                  ! epaisseur neigeuse
+c
+      REAL,allocatable,save :: falbe(:,:)
+c$OMP THREADPRIVATE(falbe)
+cym      SAVE falbe                  ! albedo par type de surface
+      REAL,allocatable,save :: falblw(:,:)
+c$OMP THREADPRIVATE(falblw)      
+cym      SAVE falblw                 ! albedo par type de surface
 
 c
@@ -644,73 +724,94 @@
 c  Parametres de l'Orographie a l'Echelle Sous-Maille (OESM):
 c
-      REAL zmea(klon)
-      SAVE zmea                   ! orographie moyenne
-c
-      REAL zstd(klon)
-      SAVE zstd                   ! deviation standard de l'OESM
-c
-      REAL zsig(klon)
-      SAVE zsig                   ! pente de l'OESM
-c
-      REAL zgam(klon)
-      save zgam                   ! anisotropie de l'OESM
-c
-      REAL zthe(klon)
-      SAVE zthe                   ! orientation de l'OESM
-c
-      REAL zpic(klon)
-      SAVE zpic                   ! Maximum de l'OESM
-c
-      REAL zval(klon)
-      SAVE zval                   ! Minimum de l'OESM
-c
-      REAL rugoro(klon)
-      SAVE rugoro                 ! longueur de rugosite de l'OESM
+      REAL,allocatable,save :: zmea(:)
+c$OMP THREADPRIVATE(zmea)
+cym      SAVE zmea                   ! orographie moyenne
+c
+      REAL,allocatable,save :: zstd(:)
+c$OMP THREADPRIVATE(zstd)
+cym      SAVE zstd                   ! deviation standard de l'OESM
+c
+      REAL,allocatable,save :: zsig(:)
+c$OMP THREADPRIVATE(zsig)
+cym      SAVE zsig                   ! pente de l'OESM
+c
+      REAL,allocatable,save :: zgam(:)
+c$OMP THREADPRIVATE(zgam)
+cym      save zgam                   ! anisotropie de l'OESM
+c
+      REAL,allocatable,save :: zthe(:)
+c$OMP THREADPRIVATE(zthe)      
+cym      SAVE zthe                   ! orientation de l'OESM
+c
+      REAL,allocatable,save :: zpic(:)
+c$OMP THREADPRIVATE(zpic)
+cym      SAVE zpic                   ! Maximum de l'OESM
+c
+      REAL,allocatable,save :: zval(:)
+c$OMP THREADPRIVATE(zval)
+cym      SAVE zval                   ! Minimum de l'OESM
+c
+      REAL,allocatable,save :: rugoro(:)
+c$OMP THREADPRIVATE(rugoro)
+cym      SAVE rugoro                 ! longueur de rugosite de l'OESM
 c
 cIM 141004     REAL zulow(klon),zvlow(klon),zustr(klon), zvstr(klon)
       REAL zulow(klon),zvlow(klon)
 c
-      REAL zuthe(klon),zvthe(klon)
-      SAVE zuthe
-      SAVE zvthe
+      REAL,allocatable,save :: zuthe(:),zvthe(:)
+c$OMP THREADPRIVATE(zuthe,zvthe)
+cym      SAVE zuthe
+cym      SAVE zvthe
       INTEGER igwd,idx(klon),itest(klon)
 c
-      REAL agesno(klon,nbsrf)
-      SAVE agesno                 ! age de la neige
-c
-      REAL alb_neig(klon)
-      SAVE alb_neig               ! albedo de la neige
-c
-      REAL run_off_lic_0(klon)
-      SAVE run_off_lic_0
+      REAL,allocatable,save :: agesno(:,:)
+c$OMP THREADPRIVATE(agesno)
+cym      SAVE agesno                 ! age de la neige
+c
+      REAL,allocatable,save :: alb_neig(:)
+c$OMP THREADPRIVATE(alb_neig)
+cym      SAVE alb_neig               ! albedo de la neige
+c
+      REAL,allocatable,save :: run_off_lic_0(:)
+c$OMP THREADPRIVATE(run_off_lic_0)
+cym      SAVE run_off_lic_0
 cKE43
 c Variables liees a la convection de K. Emanuel (sb):
 c
-      REAL ema_workcbmf(klon)   ! cloud base mass flux
-      SAVE ema_workcbmf
-
-      REAL ema_cbmf(klon)       ! cloud base mass flux
-      SAVE ema_cbmf
-
-      REAL ema_pcb(klon)        ! cloud base pressure
-      SAVE ema_pcb
-
-      REAL ema_pct(klon)        ! cloud top pressure
-      SAVE ema_pct
+      REAL,allocatable,save :: ema_workcbmf(:)   ! cloud base mass flux
+c$OMP THREADPRIVATE(ema_workcbmf)
+cym      SAVE ema_workcbmf
+
+      REAL,allocatable,save :: ema_cbmf(:)       ! cloud base mass flux
+c$OMP THREADPRIVATE(ema_cbmf)
+cym      SAVE ema_cbmf
+
+      REAL,allocatable,save :: ema_pcb(:)        ! cloud base pressure
+c$OMP THREADPRIVATE(ema_pcb)
+cym      SAVE ema_pcb
+
+      REAL,allocatable,save :: ema_pct(:)        ! cloud top pressure
+c$OMP THREADPRIVATE(ema_pct)
+cym      SAVE ema_pct
 
       REAL bas, top             ! cloud base and top levels
       SAVE bas
       SAVE top
-
-      REAL Ma(klon,klev)        ! undilute upward mass flux
-      SAVE Ma
-      REAL qcondc(klon,klev)    ! in-cld water content from convect
-      SAVE qcondc 
-      REAL ema_work1(klon, klev), ema_work2(klon, klev)
-      SAVE ema_work1, ema_work2
+c$OMP THREADPRIVATE(bas, top)
+
+      REAL,allocatable,save :: Ma(:,:)        ! undilute upward mass flux
+c$OMP THREADPRIVATE(Ma)
+cym      SAVE Ma
+      REAL,allocatable,save :: qcondc(:,:)    ! in-cld water content from convect
+c$OMP THREADPRIVATE(qcondc)
+cym      SAVE qcondc 
+      REAL,allocatable,save :: ema_work1(:, :), ema_work2(:, :)
+c$OMP THREADPRIVATE(ema_work1,ema_work2)
+cym      SAVE ema_work1, ema_work2
       REAL wdn(klon), tdn(klon), qdn(klon)
 
-      REAL wd(klon) ! sb
-      SAVE wd       ! sb
+      REAL,allocatable,save :: wd(:) ! sb
+c$OMP THREADPRIVATE(wd)
+cym      SAVE wd       ! sb
 
 c Variables locales pour la couche limite (al1):
@@ -730,19 +831,26 @@
       REAL yu1(klon)            ! vents dans la premiere couche U
       REAL yv1(klon)            ! vents dans la premiere couche V
-      REAL ffonte(klon,nbsrf)    !Flux thermique utilise pour fondre la neige
-      REAL fqcalving(klon,nbsrf) !Flux d'eau "perdue" par la surface 
+      REAL,SAVE,ALLOCATABLE :: ffonte(:,:)    !Flux thermique utilise pour fondre la neige
+c$OMP THREADPRIVATE(ffonte)
+      REAL,SAVE,ALLOCATABLE :: fqcalving(:,:) !Flux d'eau "perdu" par la surface 
+c$OMP THREADPRIVATE(fqcalving)
+      REAL,SAVE,ALLOCATABLE :: fqfonte(:,:)  !Quantite d'eau de fonte des glaciers
+c$OMP THREADPRIVATE(fqfonte)
 c                               !et necessaire pour limiter la
 c                               !hauteur de neige, en kg/m2/s
-      REAL zxffonte(klon), zxfqcalving(klon)
-
-c$$$      LOGICAL offline           ! Controle du stockage ds "physique"
-c$$$      PARAMETER (offline=.false.)
-c$$$      INTEGER physid
-      REAL pfrac_impa(klon,klev)! Produits des coefs lessivage impaction
-      save pfrac_impa
-      REAL pfrac_nucl(klon,klev)! Produits des coefs lessivage nucleation
-      save pfrac_nucl
-      REAL pfrac_1nucl(klon,klev)! Produits des coefs lessi nucl (alpha = 1)
-      save pfrac_1nucl
+      REAL zxffonte(klon), zxfqcalving(klon),zxfqfonte(klon)
+
+c@$$      LOGICAL offline           ! Controle du stockage ds "physique"
+c@$$      PARAMETER (offline=.false.)
+c@$$      INTEGER physid
+      REAL,allocatable,save :: pfrac_impa(:,:)! Produits des coefs lessivage impaction
+c$OMP THREADPRIVATE(pfrac_impa)
+cym      save pfrac_impa
+      REAL,allocatable,save :: pfrac_nucl(:,:)! Produits des coefs lessivage nucleation
+c$OMP THREADPRIVATE(pfrac_nucl)
+cym      save pfrac_nucl
+      REAL,allocatable,save :: pfrac_1nucl(:,:)! Produits des coefs lessi nucl (alpha = 1)
+c$OMP THREADPRIVATE(pfrac_1nucl)
+cym      save pfrac_1nucl
       REAL frac_impa(klon,klev) ! fractions d'aerosols lessivees (impaction)
       REAL frac_nucl(klon,klev) ! idem (nucleation)
@@ -753,18 +861,24 @@
 
 cAA
-      REAL rain_fall(klon) ! pluie
-      REAL snow_fall(klon) ! neige
-      save snow_fall, rain_fall
+      REAL,allocatable,save :: rain_fall(:) ! pluie
+c$OMP THREADPRIVATE(rain_fall)
+      REAL,allocatable,save :: snow_fall(:) ! neige
+c$OMP THREADPRIVATE(snow_fall)
+cym      save snow_fall, rain_fall
+
 cIM cf FH pour Tiedtke 080604
       REAL rain_tiedtke(klon),snow_tiedtke(klon)
 c
-      REAL total_rain(klon), nday_rain(klon)
-      save nday_rain
-c
+
+      REAL,allocatable,save :: total_rain(:), nday_rain(:)
+c$OMP THREADPRIVATE(total_rain,nday_rain)
+cym      save total_rain, nday_rain
+cIM 050204 END
       REAL evap(klon), devap(klon) ! evaporation et sa derivee
       REAL sens(klon), dsens(klon) ! chaleur sensible et sa derivee
-      REAL dlw(klon)    ! derivee infra rouge
+      REAL,allocatable,save :: dlw(:)    ! derivee infra rouge
+c$OMP THREADPRIVATE(dlw)
 cym
-      SAVE dlw
+cym      SAVE dlw
 cym
       REAL bils(klon) ! bilan de chaleur au sol
@@ -773,6 +887,7 @@
       REAL wfbils(klon,nbsrf) ! bilan de chaleur au sol, pour chaque
 C                             ! type de sous-surface et pondere par la fraction
-      REAL fder(klon) ! Derive de flux (sensible et latente) 
-      save fder
+      REAL,allocatable,save :: fder(:) ! Derive de flux (sensible et latente)
+c$OMP THREADPRIVATE(fder) 
+cym      save fder
       REAL ve(klon) ! integr. verticale du transport meri. de l'energie
       REAL vq(klon) ! integr. verticale du transport meri. de l'eau
@@ -780,6 +895,7 @@
       REAL uq(klon) ! integr. verticale du transport zonal de l'eau
 c
-      REAL frugs(klon,nbsrf) ! longueur de rugosite
-      save frugs
+      REAL,allocatable,save :: frugs(:,:) ! longueur de rugosite
+c$OMP THREADPRIVATE(frugs) 
+cym      save frugs
       REAL zxrugs(klon) ! longueur de rugosite
 c
@@ -790,17 +906,27 @@
       INTEGER lmt_pas
       SAVE lmt_pas                ! frequence de mise a jour
-      REAL pctsrf(klon,nbsrf)
+c$OMP THREADPRIVATE(lmt_pas) 
+      REAL,allocatable,save :: pctsrf(:,:)
+c$OMP THREADPRIVATE(pctsrf) 
 cIM
       REAL pctsrf_new(klon,nbsrf) !pourcentage surfaces issus d'ORCHIDEE
-      REAL paire_ter(klon)        !surfaces terre 
-c
-      SAVE pctsrf                 ! sous-fraction du sol
-      REAL albsol(klon)
-      SAVE albsol                 ! albedo du sol total
-      REAL albsollw(klon)
-      SAVE albsollw                 ! albedo du sol total
-
-      REAL wo(klon,klev)
-      SAVE wo                     ! ozone
+
+cym      REAL paire_ter(klon)        !surfaces terre 
+      REAL,allocatable,save ::  paire_ter(:)        !surfaces terre 
+c$OMP THREADPRIVATE(paire_ter) 
+    
+cIM
+cym      SAVE pctsrf                 ! sous-fraction du sol
+      REAL,allocatable,save :: albsol(:)
+c$OMP THREADPRIVATE(albsol)
+cym      SAVE albsol                 ! albedo du sol total
+      REAL,allocatable,save :: albsollw(:)
+c$OMP THREADPRIVATE(albsollw)      
+cym      SAVE albsollw                 ! albedo du sol total
+
+      REAL,allocatable,save :: wo(:,:)
+c$OMP THREADPRIVATE(wo)
+cym     SAVE wo                     ! ozone
+
 cIM sorties
       REAL un_jour
@@ -849,11 +975,9 @@
 c Variables locales
 c
-      real clwcon(klon,klev),rnebcon(klon,klev)
-      real clwcon0(klon,klev),rnebcon0(klon,klev)
-cIM cf. AM 081204 BEG
-      real clwcon0th(klon,klev),rnebcon0th(klon,klev)
-cIM cf. AM 081204 END
-      save rnebcon, clwcon
-
+      real,allocatable,save :: clwcon(:,:),rnebcon(:,:)
+c$OMP THREADPRIVATE(clwcon,rnebcon)
+      real,allocatable,save :: clwcon0(:,:),rnebcon0(:,:)
+cym      save rnebcon, clwcon
+c$OMP THREADPRIVATE(clwcon0,rnebcon0)
       REAL rhcl(klon,klev)    ! humiditi relative ciel clair
       REAL dialiq(klon,klev)  ! eau liquide nuageuse
@@ -875,27 +999,39 @@
       REAL zxfluxv(klon, klev)
 CXXX
-      REAL heat(klon,klev)    ! chauffage solaire
-      REAL heat0(klon,klev)   ! chauffage solaire ciel clair
-      REAL cool(klon,klev)    ! refroidissement infrarouge
-      REAL cool0(klon,klev)   ! refroidissement infrarouge ciel clair
-      REAL topsw(klon), toplw(klon), solsw(klon), sollw(klon)
-      real sollwdown(klon)    ! downward LW flux at surface
+      REAL,allocatable,save :: heat(:,:)    ! chauffage solaire
+c$OMP THREADPRIVATE(heat)
+      REAL,allocatable,save :: heat0(:,:)   ! chauffage solaire ciel clair
+c$OMP THREADPRIVATE(heat0)
+      REAL,allocatable,save :: cool(:,:)    ! refroidissement infrarouge
+c$OMP THREADPRIVATE(cool)
+      REAL,allocatable,save :: cool0(:,:)   ! refroidissement infrarouge ciel clair
+c$OMP THREADPRIVATE(cool0)
+      REAL,allocatable,save :: topsw(:), toplw(:), solsw(:), sollw(:)
+c$OMP THREADPRIVATE(topsw,toplw,solsw,sollw)
+      real,allocatable,save :: sollwdown(:)    ! downward LW flux at surface
+c$OMP THREADPRIVATE(sollwdown)
 cIM BEG
-      real sollwdownclr(klon)    ! downward CS LW flux at surface 
-      real toplwdown(klon)       ! downward CS LW flux at TOA
-      real toplwdownclr(klon)    ! downward CS LW flux at TOA
+      real,allocatable,save :: sollwdownclr(:)    ! downward CS LW flux at surface 
+c$OMP THREADPRIVATE(sollwdownclr)
+      real,allocatable,save :: toplwdown(:)       ! downward CS LW flux at TOA
+c$OMP THREADPRIVATE(toplwdown)
+      real,allocatable,save :: toplwdownclr(:)    ! downward CS LW flux at TOA
+c$OMP THREADPRIVATE(toplwdownclr)
 cIM END
-      REAL topsw0(klon), toplw0(klon), solsw0(klon), sollw0(klon)
-      REAL albpla(klon)
+      REAL,allocatable,save :: topsw0(:),toplw0(:),solsw0(:),sollw0(:)
+c$OMP THREADPRIVATE( topsw0,toplw0,solsw0,sollw0)
+      REAL,allocatable,save :: albpla(:)
+c$OMP THREADPRIVATE(albpla)
       REAL fsollw(klon, nbsrf)   ! bilan flux IR pour chaque sous surface
       REAL fsolsw(klon, nbsrf)   ! flux solaire absorb. pour chaque sous surface
 c Le rayonnement n'est pas calcule tous les pas, il faut donc
 c                      sauvegarder les sorties du rayonnement
-      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
-      SAVE  sollwdownclr, toplwdown, toplwdownclr
-      SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
+cym      SAVE  heat,cool,albpla,topsw,toplw,solsw,sollw,sollwdown
+cym      SAVE  sollwdownclr, toplwdown, toplwdownclr
+cym      SAVE  topsw0,toplw0,solsw0,sollw0, heat0, cool0
 c
       INTEGER itaprad
       SAVE itaprad
+c$OMP THREADPRIVATE(itaprad)
 c
       REAL conv_q(klon,klev) ! convergence de l'humidite (kg/kg/s)
